// ChatView.cpp : implementation file
//

#include "stdafx.h"
#include "PabloDraw.h"
#include "ChatView.h"
#include "MainFrm.h"

#define ID_EDIT		3
#define ID_HISTORY	4


// CChatView

CChatView::CChatView()
{
	m_pParentFrame = NULL;
}

CChatView::~CChatView()
{
}


BEGIN_MESSAGE_MAP(CChatView, CWnd)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_MESSAGE(WM_USER_RETURN, OnSelected)
	ON_WM_SETFOCUS()
END_MESSAGE_MAP()



// CChatView message handlers


int CChatView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	CRect rect;
	GetClientRect(rect);
	CFont font;
	font.Attach(GetStockObject(DEFAULT_GUI_FONT));
	CRect rectListBox = rect;
	rectListBox.bottom-=20;
	DWORD style = WS_VISIBLE | WS_CHILD | ES_MULTILINE | ES_READONLY | ES_AUTOVSCROLL | WS_VSCROLL;
	m_chatHistory.CreateRichEdit(style, rectListBox, this, ID_HISTORY);
	m_chatHistory.SetFont(&font);

	CRect rectEdit = rect;
	rectEdit.top = rectListBox.bottom;
	m_edit.Create(ES_WANTRETURN | ES_MULTILINE | WS_VISIBLE | WS_CHILD | ES_AUTOHSCROLL | ES_AUTOVSCROLL , rectEdit, this, ID_EDIT);
	m_edit.SetFont(&font);

	return 0;
}

void CChatView::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	CRect rect;
	GetClientRect(rect);
	CRect rectListBox = rect;
	rectListBox.bottom-=20;
	m_chatHistory.MoveWindow(rectListBox);

	CRect rectEdit = rect;
	rectEdit.top = rectListBox.bottom;
	m_edit.MoveWindow(rectEdit);
}

void CChatView::AddMessage(LPCTSTR p_tszMessage)
{
	CString str;
	CTime time = CTime::GetCurrentTime();

	int i = m_chatHistory.GetWindowTextLength();
	m_chatHistory.SendMessage(EM_SETSEL, (WPARAM)i, (LPARAM)i);

	CString strMessage;
	strMessage.Format(_T("\n[%.2i:%.2i] %s"), time.GetHour(), time.GetMinute(), p_tszMessage);
	CPoint pt;
	m_chatHistory.SendMessage(EM_GETSCROLLPOS, 0, (LPARAM)(POINT*)&pt);

	m_chatHistory.ReplaceSel(strMessage);
	pt.SetPoint(0,m_chatHistory.GetScrollLimit(SB_VERT));
	m_chatHistory.SendMessage(EM_SETSCROLLPOS, 0, (LPARAM)(POINT*)&pt);
}


LRESULT CChatView::OnSelected(WPARAM wParam, LPARAM lParam)
{
	LPCTSTR tszMessage = (LPCTSTR)wParam;
	ASSERT(tszMessage);
	if (GetParentFrameWnd()->GetDocument()->GetClientSocket())
	{
		GetParentFrameWnd()->GetDocument()->GetClientSocket()->Message(tszMessage);
	}
	return 0;
}

void CChatView::OnSetFocus(CWnd* pOldWnd)
{
	CWnd::OnSetFocus(pOldWnd);
	m_edit.SetFocus();
}
