// ClientOptionsDialog.cpp : implementation file
//

#include "stdafx.h"
#include "PabloDraw.h"
#include "ClientOptionsDialog.h"
#include ".\clientoptionsdialog.h"
#include "cFileDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClientOptionsDialog dialog


CClientOptionsDialog::CClientOptionsDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CClientOptionsDialog::IDD, pParent)
{
	m_strAlias = _T("");
	m_uiPort = 700;
	m_strIP = _T("");
}


void CClientOptionsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SPIN_PORT, m_ctlSpin);
	DDX_Text(pDX, IDC_EDIT_ALIAS, m_strAlias);
	DDV_MaxChars(pDX, m_strAlias, 50);
	DDX_Text(pDX, IDC_EDIT_PORT, m_uiPort);
	DDV_MinMaxUInt(pDX, m_uiPort, 0, 65535);
	DDX_Text(pDX, IDC_EDIT_IP, m_strIP);
	m_ctlSpin.SetRange32(0,65535);

	DDX_Control(pDX, IDC_CHECK1, m_autosave);
	DDX_Control(pDX, IDC_EDIT1, m_editAutosaveFile);
	DDX_Control(pDX, IDC_SELECT_FILE, m_bSelect);

	if (pDX->m_bSaveAndValidate)
	{
		if (m_strAlias.IsEmpty())
		{
			MessageBox(_T("You must enter an Alias"));
			pDX->Fail();
		}
		CString str;
		m_editAutosaveFile.GetWindowText(str);
		if (m_autosave.GetCheck() == 1 && str.IsEmpty())
		{
			MessageBox(_T("Please specify an autosave file"));
			pDX->Fail();
		}
	}
}


BEGIN_MESSAGE_MAP(CClientOptionsDialog, CDialog)
	ON_BN_CLICKED(IDC_SELECT_FILE, OnBnClickedSelectFile)
	ON_BN_CLICKED(IDC_CHECK1, OnBnClickedCheck1)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
END_MESSAGE_MAP()


void CClientOptionsDialog::PreInitDialog()
{
	UpdateData(FALSE);
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	m_strAlias = pApp->GetOptions()->GetDefaultAlias();
	m_autosave.SetCheck(pApp->GetOptions()->GetClientAutosaveMultiuserConnect() ? 1 : 0);
	m_editAutosaveFile.SetWindowText(pApp->GetOptions()->GetClientAutosaveFile());
	OnBnClickedCheck1();
	CDialog::PreInitDialog();
}

void CClientOptionsDialog::OnBnClickedSelectFile()
{
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
    CString strFormat = pApp->GetFormatString(FMT_SAVE);

	DWORD dwFlags = OFN_HIDEREADONLY | OFN_ENABLESIZING | OFN_OVERWRITEPROMPT;
	cFileDialog fd(FALSE, NULL, NULL, dwFlags, strFormat);
    if (fd.DoModal() == IDOK)
    {
		m_editAutosaveFile.SetWindowText(fd.GetPathName());
	}
}

void CClientOptionsDialog::OnBnClickedCheck1()
{
	if (m_autosave.GetCheck() == 1)
	{
		m_editAutosaveFile.EnableWindow(TRUE);
		m_bSelect.EnableWindow(TRUE);
	}
	else 
	{
		m_editAutosaveFile.EnableWindow(FALSE);
		m_bSelect.EnableWindow(FALSE);
	}
}

void CClientOptionsDialog::OnClose()
{

	CDialog::OnClose();
}

void CClientOptionsDialog::OnDestroy()
{
	CDialog::OnDestroy();

	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pApp->GetOptions()->SetDefaultAlias(m_strAlias);
	pApp->GetOptions()->SetClientAutosaveMultiuserConnect(m_autosave.GetCheck() == 1 ? TRUE : FALSE);
	CString str;
	m_editAutosaveFile.GetWindowText(str);
	pApp->GetOptions()->SetClientAutosaveFile(str);
}
