
// ClientSocket.cpp: implementation of the CClientSocket class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PabloDraw.h"
#include "ClientSocket.h"
#include "PabloDrawdoc.h"
#include "pablo_ver.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CClientSocket::CClientSocket(CPabloDrawDoc* pDoc, LPCTSTR p_tszAlias)
{
	if (p_tszAlias) m_strAlias = p_tszAlias;
	m_pDoc = pDoc;
    m_pFile = NULL;
	m_pCriticalSection = pDoc->GetCriticalSection();
	m_bUndoState = false;
	m_ulUndoCombine = 0;
	m_bIsClosed = false;
	m_bIsConnected = false;
}

CClientSocket::~CClientSocket()
{
	if (m_pFile) delete m_pFile;
}


void CClientSocket::Remove()
{
	m_pDoc = NULL;
/*
	if (m_pFile != NULL)
    {
		cArchive_store(ar, m_pFile);
		ar.Writeul(MT_USER_PART);
		ar.Writeul(m_strAlias.GetLength());
		ar.WriteString(m_strAlias);
		ar.Writeul(MT_CLOSE);  // send close message to server
		ar.Flush();
    }
	*/
}

void CClientSocket::Init()
{
	m_pFile = new cSocketFile(this, TRUE);
	/*
	CSingleLock sl(&m_clientMutex, TRUE);
	cBufferFile mf;
	cArchive_store(ar, &mf);

	
    ar.Writeul(MT_USER_JOIN);
	ar.Writeul(m_strAlias.GetLength());
	ar.WriteString(m_strAlias);

    ar.Flush();
	WriteMessage(mf);
	*/
}

void CClientSocket::Close()
{
	CSocket::Close();
	if (m_pFile) 
	{
		m_pFile->Close();
		delete m_pFile;
		m_pFile = NULL;
	}
}

void CClientSocket::WriteMessage(cBufferFile& mf)
{
	CSingleLock sl(&m_clientMutex, TRUE);
	if (IsClosed()) return;
	WriteMessage(m_pFile, mf);
}

void CClientSocket::WriteMessage(cSocketFile* p_pFile, cBufferFile& mf)
{
	cArchive_store(ar, p_pFile);
    ar.Writeul(MT_STARTBUFFER);
	ar.Writeul((ULONG)mf.GetLength());
	ar.Write(mf.GetBuffer(), (UINT)mf.GetLength());
    ar.Flush();
}
void CClientSocket::WriteMessage(CFile* p_pFile, cBufferFile& mf)
{
	cArchive_store(ar, p_pFile);
    ar.Writeul(MT_STARTBUFFER);
	ar.Writeul((ULONG)mf.GetLength());
	ar.Write(mf.GetBuffer(), (UINT)mf.GetLength());
    ar.Flush();
}

void CClientSocket::DeleteChar(cCanvas* pCanvas, CPoint p_point, BOOL p_bInsert)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ar.Writeul(MT_DELETECHAR);
	ar.Writeuc((p_bInsert) ? 1 : 0);
	ar.WritePt(p_point);
    ar.Flush();
	WriteMessage(mf);
}

void CClientSocket::InsertChar(cCanvas* pCanvas, CPoint p_point, sCanvasElement p_ce, BOOL p_bInsert)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ar.Writeul(MT_INSERTCHAR);
	ar.Writeuc((p_bInsert) ? 1 : 0);
	ar.WritePt(p_point);
	ar.Writeus(p_ce.value);
    ar.Flush();
	WriteMessage(mf);
}

void CClientSocket::Clear(cCanvas* pCanvas)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ar.Writeul(MT_CLEAR);
	ar.WriteSz(pCanvas->GetSize());
    ar.Flush();
	WriteMessage(mf);
}		   

BOOL CClientSocket::IsClosed()
{
	if (m_bIsClosed)
	{
		//this->m_pDoc->PostMessage(WM_USER_KILLCLIENT, (WPARAM)this);
		return true;
	}
	return false;
}

void CClientSocket::DeleteColumn(cCanvas* pCanvas, int p_iColumn)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
    ar.Writeul(MT_DELETECOL);
	ar.Writeul(p_iColumn);
    ar.Flush();
	WriteMessage(mf);
}
void CClientSocket::InsertColumn(cCanvas* pCanvas, int p_iColumn)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
    ar.Writeul(MT_INSERTCOL);
	ar.Writeul(p_iColumn);
    ar.Flush();
	WriteMessage(mf);
}
void CClientSocket::DeleteLine(cCanvas* pCanvas, int p_iLine)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
    ar.Writeul(MT_DELETELINE);
	ar.Writeul(p_iLine);
    ar.Flush();
	WriteMessage(mf);
}
void CClientSocket::InsertLine(cCanvas* pCanvas, int p_iLine)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
    ar.Writeul(MT_INSERTLINE);
	ar.Writeul(p_iLine);
    ar.Flush();
	WriteMessage(mf);
}
void CClientSocket::FillChar(cCanvas* pCanvas, CRect rect, UCHAR p_ucChar)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ar.Writeul(MT_FILL_CHAR);
    ar.WriteRc(rect);
	ar.Writeuc(p_ucChar);
	ar.Flush();
	WriteMessage(mf);
}

void CClientSocket::FillAttr(cCanvas* pCanvas, CRect rect, UCHAR p_ucAttr)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ar.Writeul(MT_FILL_ATTR);
    ar.WriteRc(rect);
	ar.Writeuc(p_ucAttr);
	ar.Flush();
	WriteMessage(mf);
}

void CClientSocket::FillFore(cCanvas* pCanvas, CRect rect, UCHAR p_ucFore)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ar.Writeul(MT_FILL_FORE);
    ar.WriteRc(rect);
	ar.Writeuc(p_ucFore);
	ar.Flush();
	WriteMessage(mf);
}

void CClientSocket::FillBack(cCanvas* pCanvas, CRect rect, UCHAR p_ucBack)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ar.Writeul(MT_FILL_BACK);
    ar.WriteRc(rect);
	ar.Writeuc(p_ucBack);
	ar.Flush();
	WriteMessage(mf);
}

void CClientSocket::ResizeCanvas(CSize p_size)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ar.Writeul(MT_RESIZE);
	ar.Writeul(p_size.cx);
	ar.Writeul(p_size.cy);
	ar.Flush();
	WriteMessage(mf);
}

void CClientSocket::Delete(cCanvas* pCanvas, CRect rect)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ar.Writeul(MT_DELETE_RECT);
    ar.WriteRc(rect);
	ar.Flush();
	WriteMessage(mf);
}

void CClientSocket::Erase(cCanvas* pCanvas, CRect rect)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ar.Writeul(MT_ERASE_RECT);
    ar.WriteRc(rect);
	ar.Flush();
	WriteMessage(mf);
}

void CClientSocket::Undo(cCanvas* pCanvas)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ar.Writeul(MT_UNDO);
	ar.Flush();
	WriteMessage(mf);
}

void CClientSocket::ClearFile()
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ar.Writeul(MT_CLEARFILE);
	ar.Flush();
	WriteMessage(mf);
}

void CClientSocket::Redo(cCanvas* pCanvas)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ar.Writeul(MT_REDO);
	ar.Flush();
	WriteMessage(mf);
}
void CClientSocket::UndoCombine(ULONG ulUndoCombine)
{										 
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ar.Writeul(MT_UNDOCOMBINE);
	ar.Writeul(ulUndoCombine);
	ar.Flush();
	WriteMessage(mf);
}


void CClientSocket::Message(LPCTSTR p_tszMessage)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ASSERT(p_tszMessage);
	CString strMessage;
	strMessage.Format(_T("<%s> %s"), (LPCTSTR)m_strAlias, p_tszMessage);
    ar.Writeul(MT_MESSAGE);
	ar.Writeul(strMessage.GetLength());
	ar.WriteString(strMessage);
    ar.Flush();
	WriteMessage(mf);
}

void CClientSocket::SetNotepadMode(BOOL p_bNotepadMode)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	ar.Writeul(MT_NOTEPADMODE);
	ar.Writeuc((UCHAR)p_bNotepadMode);
	ar.Flush();
	WriteMessage(mf);
}

void CClientSocket::SendPart(cCanvas* pCanvas, CRect rect, CPoint ptDest, BOOL bPasteUnder, BOOL bPasteTransparent)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	SendPart(ar, pCanvas, rect, ptDest, m_pDoc->GetApp()->GetOptions(), bPasteUnder, bPasteTransparent);
	WriteMessage(mf);
}

void CClientSocket::SendPart(cCanvas* pCanvas, CRect rect)
{
	cBufferFile mf;
	cArchive_store(ar, &mf);
	SendPart(ar, pCanvas, rect, rect.TopLeft(), m_pDoc->GetApp()->GetOptions());
	WriteMessage(mf);
}

void CClientSocket::SendPart(cArchive& ar, cCanvas* pCanvas, CRect rect, CPoint ptDest, cOptions* p_pOptions, BOOL bPasteUnder, BOOL bPasteTransparent)
{
    rect.NormalizeRect();
	// validate rect to send
	if (rect.left > pCanvas->GetSize().cx || rect.top > pCanvas->GetSize().cy ||
		rect.bottom < 0 || rect.right < 0) 
		return;  // nothing to send
	if (rect.top < 0) rect.top = 0;
	if (rect.left < 0) rect.left = 0;
	if (rect.right > pCanvas->GetSize().cx) rect.right = pCanvas->GetSize().cx;
	if (rect.bottom > pCanvas->GetSize().cy) rect.bottom = pCanvas->GetSize().cy;
	// send to server
	ar.Writeul(MT_SENDPART);
	CRect rectDest(ptDest, rect.Size());
	CMemFile f;
	cFormatAnsi fa;

	fa.Save(&f, pCanvas, rect, p_pOptions);

	f.SeekToBegin();

	ar.Writeuc((UCHAR)bPasteUnder);
	ar.Writeuc((UCHAR)bPasteTransparent);
    ar.WriteRc(rectDest);
	ar.Writeul((ULONG)f.GetLength());
	const ULONG ulBufSize = 1024;
	char buf[ulBufSize];

	ULONG ulNumRead = ulBufSize;
	while (ulNumRead == ulBufSize)
	{
		ulNumRead = f.Read(buf, ulBufSize);
		if (ulNumRead > 0) ar.Write(buf, ulNumRead);
	}


	/*
    CPoint pt;
    for (pt.y=rect.top; pt.y<rect.bottom; pt.y++)
    {
        for (pt.x=rect.left; pt.x<rect.right; pt.x++)
        {
            ar.Writeus(pCanvas->Get(pt).value);
        }
    }
	*/
    ar.Flush();
}
void CClientSocket::OnReceive(int nErrorCode)
{
    CSocket::OnReceive(nErrorCode);

    CPabloDrawDoc* pDoc = (CPabloDrawDoc*)m_pDoc;
	//CSingleLock sl(&m_clientMutex, TRUE);
	if (IsClosed()) return;

	cArchive_load(ar, m_pFile);
	RecieveData(ar, pDoc, m_bUndoState, m_ulUndoCombine, this);
	
}

BOOL CClientSocket::RecieveData(cArchive& ar, CPabloDrawDoc* pDoc, BOOL& bUndoState, ULONG& ulUndoCombine, CClientSocket* pClientSocket, CServingSocket* pSocket)
{
	CMemFile mf;

	CSingleLock* sl;
	if (pClientSocket != NULL) sl = new CSingleLock(&pClientSocket->m_clientMutex, TRUE);
	//if (pSocket != NULL) sl = new CSingleLock(pSocket->m_pCriticalSection, TRUE);
	cArchive_store(ars, &mf);
	do
	{
        eMessageType mt = (eMessageType)ar.Readul();
		if (mt == MT_STARTBUFFER)
		{
			// read and store in memory
			int size = (int)ar.Readul();
			char* b = new char[size];
			ar.Read(b, size);
			ars.Write(b, size);
			delete [] b;
		}	
		else 
		{
			// if we get here, then the stream is corrupted somehow, or connecting to an incorrect version
			if (pClientSocket)
			{
				pClientSocket->Close();
				pDoc->DeleteClient(FALSE);
				CString strError; 
				if (pClientSocket->m_bIsConnected)
					strError = _T("There was an error communicating with the server.  Closing Connection.");
				else
					strError = _T("There was an error communicating with the server (trying to connect to a server running an older version?)");
				pDoc->PostMessage(WM_USER_ERROR_MESSAGE, (WPARAM)new CString(strError));
			}
			break;
		}
    }
	while (!ar.IsBufferEmpty());
	if (pClientSocket != NULL)
	{
		sl->Unlock();// done reading
		delete sl;
	}
	/*if (pSocket != NULL)
	{
		sl->Unlock();
		delete sl;
	}  */

	ars.Flush();
	mf.SeekToBegin();
	cArchive_load(arr, &mf);
	return ProcessMessage(arr, pDoc, bUndoState, ulUndoCombine, pClientSocket, pSocket);
}

BOOL CClientSocket::ProcessMessage(cArchive& ar, CPabloDrawDoc* pDoc, BOOL& bUndoState, ULONG& ulUndoCombine, CClientSocket* pClientSocket, CServingSocket* pSocket)
{

    cPage* pPage = pDoc->GetCurrentPage();

	cCanvas* pCanvas = (pPage) ? pPage->GetCanvas() : NULL; 

	CString str;
	ULONG ulCount;
	ULONG ulProtocolVersion;
	BOOL bInsert;
	cBufferFile mf;
	cArchive ars(&mf, CArchive::store);

    eMessageType mt;
    CRect rect;
    CSize size;
	UCHAR ucValue;
	ULONG ulLine;
    CPoint pt;
    sCanvasElement ce;
	BOOL bNotepadMode;

	//ar.Flush();
	bool sendBack = false;
	do
	{
		//CSingleLock(m_pCriticalSection, TRUE);

		mt = (eMessageType)ar.Readul();

		switch (mt)
		{
		case MT_INIT:
			str.Empty();
			ulProtocolVersion = ar.Readul();
			ulCount = ar.Readul();
			while (ulCount-- > 0) str += ar.Readc();
			if (ulProtocolVersion != PABLO_SOCKET_VERSION && pClientSocket != NULL)
			{
				pClientSocket->Close();
				pDoc->DeleteClient(FALSE);
				CString strError;
				strError.Format(_T("Incompatible versions!\n  You are running v.%s protocol v.%u\n  Server is running v.%s protocol v.%u"), PABLO_BUILD, PABLO_SOCKET_VERSION, (LPCTSTR)str, ulProtocolVersion);
				pDoc->PostMessage(WM_USER_ERROR_MESSAGE, (WPARAM)new CString(strError));
				return false;
			}

			// sucessfully connected, start receiving additional messages!
			ars.Writeul(MT_DONEINIT);
			sendBack = true;
			break;
		case MT_INITCOMPLETE:
			// received by client after everything is cool to initialize
			size.cx = ar.Readul();
			size.cy = ar.Readul();
			bNotepadMode = (BOOL)ar.Readuc();
			if (pCanvas)
			{
				if (bNotepadMode)
				{
					pCanvas->GetDefaultElement().SetAttr(0, 15);
					pCanvas->SetAttribute((pCanvas->GetFore() == 7 || pCanvas->GetFore() == 15) ? 0 : pCanvas->GetFore(), (pCanvas->GetBack() == 0) ? 15 : pCanvas->GetBack());
				}
				else
				{
					pCanvas->GetDefaultElement().SetAttr(7, 0);
					pCanvas->SetAttribute((pCanvas->GetFore() == 0) ? 7 : pCanvas->GetFore(), (pCanvas->GetBack() == 15) ? 0 : pCanvas->GetBack());
				}
			}
			if (pCanvas) pCanvas->Fill(pCanvas->GetDefaultAttribute(), pCanvas->GetDefaultCharacter());
			if (pCanvas) pCanvas->Resize(size);
			if (pCanvas) pDoc->PostMessage(WM_USER_UPDATE_CANVAS);
			if (pCanvas) pDoc->UpdateRegion(CRect(CPoint(0,0),pCanvas->GetSize()));
			// load list
			ulCount = ar.Readul();
			for (ULONG ull=0; ull < ulCount; ull++)
			{
				ULONG ulStringLen = ar.Readul();
				CString strUser;
				ar.Read((void*)strUser.GetBufferSetLength(ulStringLen), ulStringLen);
				pDoc->PostMessage(WM_USER_JOINED, (WPARAM)new CString(strUser));
			}

			ars.Writeul(MT_USER_JOIN);
			ars.Writeul(pClientSocket->m_strAlias.GetLength());
			ars.WriteString(pClientSocket->m_strAlias);
			pClientSocket->m_bIsConnected = TRUE;
			pClientSocket->m_bNotepadMode = bNotepadMode;
			pDoc->PostMessage(WM_USER_UPDATE_CANVAS, 1); // invalidate screen
			pDoc->PostMessage(WM_USER_UPDATE_CANVAS, 5); // update color!
			sendBack = true;
			break;

		case MT_DONEINIT:
			// received on server end by the client signifying everything is cool.
			if (pSocket != NULL)
			{
				pSocket->SetUserJoined(TRUE);
				// send back the current state of the server canvas!
				pSocket->SendCurrentState(ars);
				sendBack = true;
			}
			break;
		case MT_RESIZE:
			size.cx = ar.Readul();
			size.cy = ar.Readul();
			if (pSocket)
			{
				ars.Writeul(mt);
				ars.Writeul(size.cx);
				ars.Writeul(size.cy);
			}
			if (pCanvas) 
			{
				pCanvas->Resize(size);
				pDoc->PostMessage(WM_USER_UPDATE_CANVAS);
				pDoc->UpdateAllViews(NULL);
			}
			break;

		case MT_CLEARFILE:
			if (pSocket) ars.Writeul(mt);
			if (!pSocket) pDoc->SetPathName(NULL);
			break;

		case MT_UNDOSTATE:
			bUndoState = (BOOL)ar.Readuc();
			if (pSocket) ars.Writeul(mt);
			if (pSocket) ars.Writeuc((UCHAR)bUndoState);
			break;
		case MT_UNDOCOMBINE:
			ulUndoCombine = ar.Readul();
			if (pSocket) ars.Writeul(mt);
			if (pSocket) ars.Writeul(ulUndoCombine);
			break;

		case MT_CLEAR:
			size = ar.ReadSz();
			if (pSocket) ars.Writeul(mt);
			if (pSocket) ars.WriteSz(size);
			if (bUndoState) pPage->SaveCanvas(CRect(0,0,0,0), CPoint(), UT_CLEAR, (ulUndoCombine > 0) ? (ulUndoCombine-- == 0) : TRUE);
			if (pCanvas) pCanvas->Fill(pCanvas->GetDefaultAttribute(), pCanvas->GetDefaultCharacter());
			if (pCanvas) pCanvas->Resize(size);
			if (pCanvas) pDoc->PostMessage(WM_USER_UPDATE_CANVAS);
			if (pCanvas) pDoc->UpdateRegion(CRect(CPoint(0,0),pCanvas->GetSize()));
			break;
		case MT_DELETECHAR:										
			bInsert = (ar.Readuc() == 1) ? TRUE : FALSE;
			pt = ar.ReadPt();
			if (pSocket) ars.Writeul(mt);
			if (pSocket) ars.Writeuc(bInsert ? 1 : 0);
			if (pSocket) ars.WritePt(pt);
			if (bUndoState) pPage->SaveCanvas(CRect(pt, CSize(1,1)), pt, bInsert ? UT_DELETECHAR : UT_BLOCK, (ulUndoCombine > 0) ? (ulUndoCombine-- == 0) : TRUE);
			if (pCanvas) pCanvas->DeleteChar(pt);            
			if (pCanvas) pDoc->UpdateRegion(CRect(pt,CSize(pCanvas->GetSize().cx-pt.x, 1)));
			break;
		case MT_INSERTCHAR:
			bInsert = (ar.Readuc() == 1) ? TRUE : FALSE;
			pt = ar.ReadPt();

			if (bInsert)
			{
				if (bUndoState) pPage->SaveCanvas(CRect(CPoint(pCanvas->GetSize().cx-1, pt.y), CSize(1,1)), pt, UT_BLOCK, FALSE);
				if (bUndoState) pPage->SaveCanvas(CRect(pt, CSize(1,1)), pt, UT_INSERTCHAR, (ulUndoCombine > 0) ? (ulUndoCombine-- == 0) : TRUE);
			}
			else
				if (bUndoState) pPage->SaveCanvas(CRect(pt, CSize(1,1)), pt, UT_BLOCK, (ulUndoCombine > 0) ? (ulUndoCombine-- == 0) : TRUE);

			ce.value = ar.Readus();
			if (pSocket) ars.Writeul(mt);
			if (pSocket) ars.Writeuc(bInsert ? 1 : 0);
			if (pSocket) ars.WritePt(pt);
			if (pSocket) ars.Writeus(ce.value);
			if (pCanvas) pCanvas->InsertChar(pt, ce, bInsert);
			if (pCanvas) pDoc->UpdateRegion(CRect(pt,CSize(pCanvas->GetSize().cx-pt.x, 1)));
			break;
		case MT_DELETECOL:
			ulLine = ar.Readul();
			if (pSocket) ars.Writeul(mt);
			if (pSocket) ars.Writeul(ulLine);
			if (bUndoState) pPage->SaveCanvas(CRect(0,0,0,0), CPoint(ulLine, 0), UT_DELETECOL, (ulUndoCombine > 0) ? (ulUndoCombine-- == 0) : TRUE);
			if (pCanvas) pCanvas->DeleteColumn(ulLine);
			if (pCanvas) pDoc->UpdateRegion(CRect(ulLine, 0, pCanvas->GetSize().cx, pCanvas->GetSize().cy));
			break;
		case MT_INSERTCOL:
			ulLine = ar.Readul();
			if (pSocket) ars.Writeul(mt);
			if (pSocket) ars.Writeul(ulLine);
			int iEndY;
			iEndY = pCanvas->FindEndY();
			if (bUndoState) pPage->SaveCanvas(CRect(CPoint(pCanvas->GetSize().cx-1, 0), CSize(1, iEndY)), CPoint(ulLine, 0), UT_BLOCK, FALSE);
			if (bUndoState) pPage->SaveCanvas(CRect(0,0,0,0), CPoint(ulLine, 0), UT_INSERTCOL, (ulUndoCombine > 0) ? (ulUndoCombine-- == 0) : TRUE);
			if (pCanvas) pCanvas->InsertColumn(ulLine);
			if (pCanvas) pDoc->UpdateRegion(CRect(ulLine, 0, pCanvas->GetSize().cx, pCanvas->GetSize().cy));
			break;
		case MT_DELETELINE:
			ulLine = ar.Readul();
			if (pSocket) ars.Writeul(mt);
			if (pSocket) ars.Writeul(ulLine);
			if (bUndoState) pPage->SaveCanvas(CRect(0,0,0,0), CPoint(0, ulLine), UT_DELETELINE, (ulUndoCombine > 0) ? (ulUndoCombine-- == 0) : TRUE);
			if (pCanvas) pCanvas->DeleteLine(ulLine);
			if (pCanvas) pDoc->UpdateRegion(CRect(0, ulLine, pCanvas->GetSize().cx, pCanvas->GetSize().cy));
			break;
		case MT_INSERTLINE:
			ulLine = ar.Readul();
			if (pSocket) ars.Writeul(mt);
			if (pSocket) ars.Writeul(ulLine);
			//pPage->UpdateUndoBuffer(CPoint(0,ulLine), UT_INSERTLINE);
			if (bUndoState) pPage->SaveCanvas(CRect(CPoint(0,pCanvas->GetSize().cy-1), CSize(pCanvas->GetSize().cx, 1)), CPoint(0, ulLine), UT_BLOCK, FALSE);
			if (bUndoState) pPage->SaveCanvas(CRect(0,0,0,0), CPoint(0, ulLine), UT_INSERTLINE, (ulUndoCombine > 0) ? (ulUndoCombine-- == 0) : TRUE);
			if (pCanvas) pCanvas->InsertLine(ulLine);
			if (pCanvas) pDoc->UpdateRegion(CRect(0, ulLine, pCanvas->GetSize().cx, pCanvas->GetSize().cy));
			break;
		case MT_FILL_CHAR:
			rect = ar.ReadRc();
			ucValue = ar.Readuc();
			if (pSocket) ars.Writeul(mt);
			if (pSocket) ars.WriteRc(rect);
			if (pSocket) ars.Writeuc(ucValue);
			if (bUndoState) pPage->SaveCanvas(rect, CPoint(0,0), UT_BLOCK, (ulUndoCombine > 0) ? (ulUndoCombine-- == 0) : TRUE);
			if (pCanvas) pCanvas->FillChar(ucValue, rect);
			pDoc->UpdateRegion(rect);
			break;
		case MT_FILL_ATTR:
			rect = ar.ReadRc();
			ucValue = ar.Readuc();
			if (pSocket) ars.Writeul(mt);
			if (pSocket) ars.WriteRc(rect);
			if (pSocket) ars.Writeuc(ucValue);
			if (bUndoState) pPage->SaveCanvas(rect, CPoint(0,0), UT_BLOCK, (ulUndoCombine > 0) ? (ulUndoCombine-- == 0) : TRUE);
			if (pCanvas) pCanvas->FillAttr(ucValue, rect);
			pDoc->UpdateRegion(rect);
			break;
		case MT_FILL_FORE:
			rect = ar.ReadRc();
			ucValue = ar.Readuc();
			if (pSocket) ars.Writeul(mt);
			if (pSocket) ars.WriteRc(rect);
			if (pSocket) ars.Writeuc(ucValue);
			if (bUndoState) pPage->SaveCanvas(rect, CPoint(0,0), UT_BLOCK, (ulUndoCombine > 0) ? (ulUndoCombine-- == 0) : TRUE);
			if (pCanvas) pCanvas->FillFore(ucValue, rect);
			pDoc->UpdateRegion(rect);
			break;
		case MT_FILL_BACK:
			rect = ar.ReadRc();
			ucValue = ar.Readuc();
			if (pSocket) ars.Writeul(mt);
			if (pSocket) ars.WriteRc(rect);
			if (pSocket) ars.Writeuc(ucValue);
			if (bUndoState) pPage->SaveCanvas(rect, CPoint(0,0), UT_BLOCK, (ulUndoCombine > 0) ? (ulUndoCombine-- == 0) : TRUE);
			if (pCanvas) pCanvas->FillBack(ucValue, rect);
			pDoc->UpdateRegion(rect);
			break;
		case MT_DELETE_RECT:
			rect = ar.ReadRc();
			if (pSocket) ars.Writeul(mt);
			if (pSocket) ars.WriteRc(rect);
			if (pCanvas)
			{
				if (bUndoState) pPage->SaveCanvas(rect, CPoint(0,0), UT_BLOCK, (ulUndoCombine > 0) ? (ulUndoCombine-- == 0) : TRUE);
				pCanvas->Delete(rect);
				rect.left = 0;
				rect.right = pCanvas->GetSize().cx;
				pDoc->UpdateRegion(rect);
			}
			break;
		case MT_ERASE_RECT:
			rect = ar.ReadRc();
			if (pSocket) ars.Writeul(mt);
			if (pSocket) ars.WriteRc(rect);
			if (bUndoState) pPage->SaveCanvas(rect, CPoint(0,0), UT_BLOCK, (ulUndoCombine > 0) ? (ulUndoCombine-- == 0) : TRUE);
			if (pCanvas) pCanvas->Fill(pCanvas->GetDefaultAttribute(), pCanvas->GetDefaultCharacter(), rect);
			if (pCanvas) pDoc->UpdateRegion(rect);
			break;
		case MT_NOTEPADMODE:
			bNotepadMode = (BOOL)ar.Readuc();
			if (pSocket)
			{
				ars.Writeul(mt);
				ars.Writeuc(bNotepadMode);
			}

			if (pClientSocket)
			{
				pClientSocket->m_bNotepadMode = bNotepadMode;
			}

			if (pCanvas)
			{
				if (bNotepadMode)
				{
					pCanvas->ChangeDefaultAttribute(0, 15);
					pCanvas->SetAttribute((pCanvas->GetFore() == 7 || pCanvas->GetFore() == 15) ? 0 : pCanvas->GetFore(), (pCanvas->GetBack() == 0) ? 15 : pCanvas->GetBack());
				}
				else
				{
					pCanvas->ChangeDefaultAttribute(7, 0);
					pCanvas->SetAttribute((pCanvas->GetFore() == 0) ? 7 : pCanvas->GetFore(), (pCanvas->GetBack() == 15) ? 0 : pCanvas->GetBack());
				}
				pDoc->UpdateRegion(CRect(CPoint(0,0),pCanvas->GetSize()));
				pDoc->PostMessage(WM_USER_UPDATE_CANVAS, 1); // invalidate screen
				pDoc->PostMessage(WM_USER_UPDATE_CANVAS, 5); // update color!
			}
			break;
		case MT_SENDPART:
			{
			BOOL bPasteUnder = (BOOL)ar.Readuc();
			BOOL bPasteTransparent = (BOOL)ar.Readuc();
			rect = ar.ReadRc();

			if (bUndoState) pPage->SaveCanvas(rect, CPoint(0,0), UT_BLOCK, (ulUndoCombine > 0) ? (ulUndoCombine-- == 0) : TRUE);


			{
				CMemFile mf;
				ULONG ulTotalBytes = ar.Readul();
				ULONG ulBytesLeft = ulTotalBytes;

				const ULONG ulBufSize = 1024;
				char buf[ulBufSize];
				while (ulBytesLeft > 0)
				{
					ULONG ulBytesToRead = (ulBytesLeft > ulBufSize) ? ulBufSize : ulBytesLeft;
					ar.Read(buf, ulBytesToRead);
					ulBytesLeft -= ulBytesToRead;
					mf.Write(buf, ulBytesToRead);
				}

				if (pSocket)
				{
					mf.SeekToBegin();
					ars.Writeul(mt);
					ars.Writeuc((BOOL)bPasteUnder);
					ars.Writeuc((BOOL)bPasteTransparent);
					ars.WriteRc(rect);
					ars.Writeul(ulTotalBytes);
					do
					{
						ulBytesLeft = mf.Read(buf, ulBufSize);
						if (ulBytesLeft > 0) ars.Write(buf, ulBytesLeft);
					}
					while (ulBytesLeft == ulBufSize);
				}

				mf.SeekToBegin();
				if (bPasteUnder || bPasteTransparent)
				{
					cMemCanvas canvas(rect.Size());
					canvas.SetDefaultElement(pCanvas->GetDefaultElement());
					cFormatAnsi fa;
					fa.Load(&mf, &canvas, CRect(CPoint(0,0), rect.Size()), pDoc->GetApp()->GetOptions());
					pCanvas->Set(CPoint(0,0), &canvas, rect.TopLeft(), rect.Size(), pDoc->GetApp()->GetOptions(), bPasteUnder, bPasteTransparent);
				}
				else
				{
					pCanvas->Fill(pCanvas->GetDefaultAttribute(), pCanvas->GetDefaultCharacter(), rect);
					cFormatAnsi fa;
					fa.Load(&mf, pCanvas, rect, pDoc->GetApp()->GetOptions());
				}
			}
			pDoc->UpdateRegion(rect);
			break;
			}
		case MT_USER_JOIN:
			{
			if (pSocket)
			{
				// server
				pDoc->Autosave(FALSE); // autosave is asked to do so
				ulCount = ar.Readul();
				CString str;
				ar.Read((void*)str.GetBufferSetLength(ulCount), ulCount);
				pSocket->m_strAlias = str;
				ars.Writeul(mt);
				ars.Writeul(ulCount);
				ars.Write(str.GetBuffer(), ulCount);
			}
			else
			{
				// client
				ulCount = ar.Readul();
				ar.Read((void*)str.GetBufferSetLength(ulCount), ulCount);
				pDoc->PostMessage(WM_USER_JOINED, (WPARAM)new CString(str), (LPARAM)TRUE);
				CString strMsg;
				strMsg.Format(_T("*** %s has joined"), str);
				pDoc->PostMessage(WM_USER_ADD_MESSAGE, (WPARAM)new CString(strMsg));
			}
			break;
			}

		case MT_USER_PART:
			{
			ULONG nErrorCode = ar.Readul();
			ulCount = ar.Readul();
			ar.Read((void*)str.GetBufferSetLength(ulCount), ulCount);
				if (pSocket)
				{
					ars.Writeul(mt);
					ars.Writeul(nErrorCode);
					ars.Writeul(ulCount);
					ars.Write(str.GetBuffer(), ulCount);
				}
				else
				{
			pDoc->PostMessage(WM_USER_PARTED, (WPARAM)new CString(str));
			CString strMsg;
			if (nErrorCode == 0)
				strMsg.Format(_T("*** %s has left"), str);
			else
				strMsg.Format(_T("*** %s has disconnected"), str);
			pDoc->PostMessage(WM_USER_ADD_MESSAGE, (WPARAM)new CString(strMsg));
				}
			break;
			}

		case MT_MESSAGE:
			ulCount = ar.Readul();
			ar.Read((void*)str.GetBufferSetLength(ulCount), ulCount);
				if (pSocket)
				{
					ars.Writeul(mt);
					ars.Writeul(ulCount);
					ars.Write(str.GetBuffer(), ulCount);
				}
				else
				{
			pDoc->PostMessage(WM_USER_ADD_MESSAGE, (WPARAM)new CString(str));
				}
			//AfxMessageBox(str);
			break;
		}
    }
	while (!ar.IsBufferEmpty());
	ars.Flush();

	if (mf.GetLength() > 0)
	{
		mf.SeekToBegin();
		ASSERT(!(pSocket != NULL && pClientSocket != NULL));
		if (pSocket)
		{
			cBufferFile mf2;
			pClientSocket->WriteMessage(&mf2, mf);
			if (sendBack)
			{
				pSocket->Send(mf2.GetBuffer(), (int)mf2.GetLength());
			}
			else if (pSocket->GetUserJoined())
			{
				pSocket->m_pListenSocket->Write(mf2.GetBuffer(), (UINT)mf2.GetLength());	
			}
		}
		else if (pClientSocket)
		{
			pClientSocket->WriteMessage(mf);
		}
	}

	return true;
//	ar.Flush();
}


IMPLEMENT_DYNAMIC(CClientSocket, CSocket);

void CClientSocket::OnClose(int nErrorCode)
{
	if (IsClosed()) return;
	CPabloDrawDoc* pDoc = (CPabloDrawDoc*)m_pDoc;
	m_bIsClosed = true;
	if (pDoc) pDoc->DeleteClient(FALSE);
	if (nErrorCode == 0)
	{
		pDoc->PostMessage(WM_USER_ERROR_MESSAGE, (WPARAM)new CString(_T("The server closed the connection")));
	}
	else
	{
		pDoc->PostMessage(WM_USER_ERROR_MESSAGE, (WPARAM)new CString(_T("The server closed the connection unexpectedly")));
	}
	CSocket::OnClose(nErrorCode);
}
