// ListeningSocket.h: interface for the CListeningSocket class.
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "ServingSocket.h"
#include "ServingSocketThread.h"
class CPabloDrawDoc;

class CServingSocketThread;

class CListeningSocket : public CSocket
{
    friend class CServingSocket;
	DECLARE_DYNAMIC(CListeningSocket);
public:
    CListeningSocket(CPabloDrawDoc* pDoc);
	virtual ~CListeningSocket();

    void DisconnectAll(CEvent* p_pev);

    void Write(const void* pBuf, UINT uiSize, CServingSocket* pSource = NULL);
    void Writeul(ULONG ulValue, CServingSocket* pSource = NULL);
    void Writeus(USHORT usValue, CServingSocket* pSource = NULL);
    void Writeuc(UCHAR ucValue, CServingSocket* pSource = NULL);
    void WriteRc(LPRECT rect, CServingSocket* pSource = NULL);
    void WriteSz(LPSIZE size, CServingSocket* pSource = NULL);
    void WritePt(LPPOINT point, CServingSocket* pSource = NULL);
	void SendPart(cCanvas* pCanvas, CRect rect, CPoint ptDest, CServingSocket* pSource = NULL);

    void FlushAll(CServingSocket* pSource = NULL);

	void GetAliasList(CStringList& p_sl, CServingSocket* pSource);
    void RemoveSocket(CServingSocketThread* pSocketThread, BOOL p_bLock = TRUE);
    void AddSocket(CServingSocketThread* pSocketThread);

	int GetNumUsers() const { return m_connectionList.GetCount(); }

	inline CPabloDrawDoc* GetDocument() { return m_pDoc; }

    CPtrList m_connectionList;
	CMutex			m_mutex;

protected:
	virtual void OnAccept(int nErrorCode);

protected:
    CPabloDrawDoc* m_pDoc;

    CEvent* m_pev;
};

