// ChildFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "PabloDraw.h"
#include "MainFrm.h"
#include "directx\ddutil.h"
#include "sAccel.h"
#include "CanvasWidthDialog.h"


CDisplay*			g_pDisplay			= NULL;
CRect				g_rectWindowed;

#define NORMAL_SETTINGS			_T("Main")
#define FULLSCREEN_SETTINGS		_T("Main-FullScreen")
#define MINI_SETTINGS			_T("Main-Mini")

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_ACTIVATE()
	ON_WM_CREATE()
	ON_WM_MOVE()
    ON_MESSAGE(WM_USER_UPDATE_COLOUR, OnUpdateColour)
	ON_MESSAGE(WM_USER_UPDATE_CHARSET, OnUpdateCharSet)
	ON_MESSAGE(WM_USER_ADD_MESSAGE, OnAddMessage)
	ON_MESSAGE(WM_USER_JOINED, OnUserJoined)
	ON_MESSAGE(WM_USER_PARTED, OnUserParted)
	ON_COMMAND(ID_SWITCHCHATEDIT, OnSwitchChatEdit)
	ON_COMMAND(ID_SHOW_CHAT_WINDOW, OnShowChatWindow)
	ON_UPDATE_COMMAND_UI(ID_SHOW_CHAT_WINDOW, OnUpdateShowChatWindow)
	ON_COMMAND(ID_VIEW_SHOW_PREVIEW, OnShowPreview)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SHOW_PREVIEW, OnUpdateShowPreview)

	ON_COMMAND(ID_CANVAS_BREAKCONNECTION, OnCanvasBreakconnection)
	ON_COMMAND(ID_CANVAS_CONNECTTOSERVER, OnCanvasConnecttoserver)
	ON_COMMAND(ID_CANVAS_STARTSERVER, OnCanvasStartserver)
	ON_UPDATE_COMMAND_UI(ID_CANVAS_BREAKCONNECTION, OnUpdateCanvasBreakconnection)
	ON_UPDATE_COMMAND_UI(ID_CANVAS_CONNECTTOSERVER, OnUpdateCanvasConnecttoserver)
	ON_UPDATE_COMMAND_UI(ID_CANVAS_STARTSERVER, OnUpdateCanvasStartserver)
	ON_COMMAND(ID_VIEW_CHARACTER_SET, OnViewCharacterSet)
	ON_UPDATE_COMMAND_UI(ID_VIEW_CHARACTER_SET, OnUpdateViewCharacterSet)
	ON_COMMAND(ID_VIEW_COLOURBAR, OnViewColourbar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_COLOURBAR, OnUpdateViewColourbar)
	ON_WM_SIZE()

	ON_COMMAND(ID_CYCLE_BACKGROUND8, OnCycleBackground8)
	ON_UPDATE_COMMAND_UI(ID_CYCLE_BACKGROUND8, OnUpdateCycleBackground8)
	ON_COMMAND(ID_ITP_COMPAT, OnItpCompat)
	ON_UPDATE_COMMAND_UI(ID_ITP_COMPAT, OnUpdateItpCompat)

	ON_COMMAND(ID_VIEW_BLINKINGCURSOR, OnBlinkingCursor)
	ON_UPDATE_COMMAND_UI(ID_VIEW_BLINKINGCURSOR, OnUpdateBlinkingCursor)
	ON_COMMAND(ID_USE_SHIFTSELECT, OnUseShiftSelect)
	ON_UPDATE_COMMAND_UI(ID_USE_SHIFTSELECT, OnUpdateUseShiftSelect)
	ON_COMMAND(ID_VIEW_NOTEPADMODE, OnNotepadMode)
	ON_UPDATE_COMMAND_UI(ID_VIEW_NOTEPADMODE, OnUpdateNotepadMode)
	ON_COMMAND(ID_ENABLEBACKUPS, OnEnableBackups)
	ON_UPDATE_COMMAND_UI(ID_ENABLEBACKUPS, OnUpdateEnableBackups)
	ON_COMMAND(ID_MULTIPLEBACKUPS, OnMultipleBackups)
	ON_UPDATE_COMMAND_UI(ID_MULTIPLEBACKUPS, OnUpdateMultipleBackups)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_MESSAGE(WM_USER_FULLSCREEN_SET, OnFullscreenSet)
	ON_COMMAND(ID_FULLSCREEN_SWITCH, OnFullscreenSwitch)
	ON_UPDATE_COMMAND_UI(ID_FULLSCREEN_SWITCH, OnUpdateFullscreenSwitch)
	ON_COMMAND(ID_MINI_SWITCH, OnMiniSwitch)
	ON_UPDATE_COMMAND_UI(ID_MINI_SWITCH, OnUpdateMiniSwitch)
	ON_COMMAND(ID_VIEW_MENUBAR, OnViewMenubar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_MENUBAR, OnUpdateViewMenubar)
	ON_COMMAND(ID_USE_WINDOWSKEYS, OnUseWindowsKeysSwitch)
	ON_UPDATE_COMMAND_UI(ID_USE_WINDOWSKEYS, OnUpdateUseWindowsKeysSwitch)
	ON_COMMAND(ID_USE_TABKEY, OnUseTabKeySwitch)
	ON_UPDATE_COMMAND_UI(ID_USE_TABKEY, OnUpdateUseTabKeySwitch)

	ON_UPDATE_COMMAND_UI(ID_INDICATOR_INS, OnUpdateInsert)

	ON_COMMAND(ID_FILE_CANVAS_WIDTH, OnSetCanvasWidth)
	ON_UPDATE_COMMAND_UI(ID_FILE_CANVAS_WIDTH, OnUpdateSetCanvasWidth)

	ON_WM_CLOSE()
	ON_COMMAND(ID_VIEW_TOOLBAR, OnViewToolbar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBAR, OnUpdateViewToolbar)
	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame(CPabloDrawDoc* p_pDocument)
{
	// TODO: add member initialization code here
	m_pDocument = p_pDocument;
	m_pView = NULL;
	m_pLastFocus = NULL;
	m_hAccelTable = NULL;
}

CMainFrame::~CMainFrame()
{
}


BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	int width = AfxGetApp()->GetProfileInt(_T("defaults"), _T("main_width"), 0);
	int height = AfxGetApp()->GetProfileInt(_T("defaults"), _T("main_height"), 0);
	BOOL zoomed = (BOOL)AfxGetApp()->GetProfileInt(_T("defaults"), _T("main_zoomed"), 0);
	if (width > 0) cs.cx = width;
	if (height > 0) cs.cy = height;

	if (zoomed) cs.style |= WS_MAXIMIZE;
	cs.style |= FWS_ADDTOTITLE;
	cs.lpszClass = AfxRegisterWndClass
		(
			CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW,
			0,
			0,
			AfxGetApp()->LoadIcon(IDR_MAINFRAME)
		);
	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	return TRUE;
}


void CMainFrame::ActivateFrame(int nCmdShow)
{
	CFrameWnd::ActivateFrame(nCmdShow);
} 

void CMainFrame::OnActivate(UINT nState,CWnd* pWndOther,BOOL bMinimized)
{
	if (nState == WA_INACTIVE)
	{
		m_pLastFocus = GetFocus();
	}
	else if (m_pLastFocus != NULL)
	{
		m_pLastFocus->SetFocus();
	}

}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
    ID_INDICATOR_POS,
	ID_INDICATOR_INS,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

void CMainFrame::SetAccelerators()
{
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();

	if (m_hAccelTable != NULL) ::DestroyAcceleratorTable(m_hAccelTable);
	CArray<ACCEL> accels;

	if (!pApp->GetOptions()->GetUseTabKey())
	{
		accels.Add(sAccel( FVIRTKEY | FNOINVERT					, VK_TAB			, ID_SWITCHCHATEDIT			));
	}
	accels.Add(sAccel( FVIRTKEY | FNOINVERT | FALT			, 'V'				, ID_VIEW_SHOW_PREVIEW		));
	accels.Add(sAccel( FVIRTKEY | FNOINVERT	| FALT			, 'X'				, ID_APP_EXIT				));
	accels.Add(sAccel( FVIRTKEY | FNOINVERT	| FALT			, 'Z'				, ID_CYCLE_BACKGROUND8		));
	accels.Add(sAccel( FVIRTKEY | FNOINVERT	| FALT			, 'L'				, ID_FILE_LOAD				));
	accels.Add(sAccel( FVIRTKEY | FNOINVERT	| FALT			, 'S'				, ID_FILE_SAVE_AS			));
	accels.Add(sAccel( FVIRTKEY | FNOINVERT	| FALT			, VK_RETURN			, ID_FULLSCREEN_SWITCH		));
	accels.Add(sAccel( FVIRTKEY | FNOINVERT	| FSHIFT		, VK_ESCAPE			, ID_VIEW_MENUBAR			));

	if (pApp->GetOptions()->GetUseWindowsKeys())
	{
		accels.Add(sAccel( FVIRTKEY | FNOINVERT	| FCONTROL		, 'L'				, ID_FILE_LOAD				));
		accels.Add(sAccel( FVIRTKEY | FNOINVERT	| FCONTROL		, 'N'				, ID_FILE_NEW				));
		accels.Add(sAccel( FVIRTKEY | FNOINVERT	| FCONTROL		, 'O'				, ID_FILE_LOAD				));
		accels.Add(sAccel( FVIRTKEY | FNOINVERT	| FCONTROL		, 'S'				, ID_FILE_SAVE				));
	}
//	accels.Add(sAccel( FVIRTKEY | FNOINVERT	, , ));

	m_hAccelTable = ::CreateAcceleratorTable(accels.GetData(), accels.GetCount());
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	SetAccelerators();
	
	CRect rect;
	GetClientRect(rect);
	m_pView = new CCanvasView();
	m_pView->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, rect, this, AFX_IDW_PANE_FIRST);
	m_pDocument->AddView(m_pView);
	m_pView->OnInitialUpdate();
	m_pViewActive = m_pView;

	CreateMenu();

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
    m_wndStatusBar.SetPaneInfo(1,ID_INDICATOR_POS,0,100);

	EnableDocking(CBRS_ALIGN_ANY);


	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP | CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC, CRect(0,0,0,0), 1) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);


    if (!m_wndPreview.Create("Preview", this, CSize(200,200), TRUE, 2, WS_CHILD|WS_VISIBLE|CBRS_GRIPPER|CBRS_RIGHT| CBRS_SIZE_DYNAMIC))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	m_wndPreview.EnableDocking(CBRS_ALIGN_ANY);
    DockControlBar(&m_wndPreview);

	if (!m_wndChat.Create("Chat", this, CSize(300,100), TRUE, 3, WS_VISIBLE|WS_CHILD|CBRS_BOTTOM|CBRS_SIZE_DYNAMIC))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
    m_wndChat.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndChat);

	if (!m_wndUserList.Create("User List", this, CSize(90, 100), TRUE, 4, WS_VISIBLE|WS_CHILD|CBRS_BOTTOM|CBRS_SIZE_DYNAMIC))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
    m_wndUserList.EnableDocking(CBRS_ALIGN_ANY);
    DockControlBarLeftOf(&m_wndUserList, &m_wndChat);



    if (!m_wndColour.Create("Colour", this, CSize(200,200), TRUE, 5, WS_CHILD|WS_VISIBLE | CBRS_BOTTOM| CBRS_SIZE_DYNAMIC))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
    m_wndColour.EnableDocking(CBRS_ALIGN_ANY);
    DockControlBar(&m_wndColour);

    if (!m_wndCharSet.Create("Character Set", this, CSize(200,200), TRUE, 6, WS_CHILD|WS_VISIBLE | CBRS_BOTTOM| CBRS_SIZE_DYNAMIC))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
    m_wndCharSet.EnableDocking(CBRS_ALIGN_ANY);
    DockControlBarLeftOf(&m_wndCharSet, &m_wndColour);

	m_wndChat.SetParentFrame(this);
	m_wndColour.SetParentFrame(this);
	m_wndCharSet.SetParentFrame(this);
	m_wndPreview.SetParentFrame(this);

	m_wndUserList.ShowWindow(SW_HIDE);
	m_wndChat.ShowWindow(SW_HIDE);

	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	LoadBarState(NORMAL_SETTINGS);
	CSizingControlBar::GlobalLoadState(this, NORMAL_SETTINGS);

	if (pApp->GetOptions()->GetStartInFullscreen()) 
	{
		PostMessage(WM_USER_FULLSCREEN_SET);
	}
	else if (pApp->GetOptions()->GetStartInMini()) 
	{
		LoadBarState(MINI_SETTINGS);
		CSizingControlBar::GlobalLoadState(this, MINI_SETTINGS);
		SendMessageToDescendants(WM_USER_MINI_SWITCH, (WPARAM)pApp->GetOptions()->GetStartInMini());
	}
	return 0;
}

void CMainFrame::OnMove(int x, int y)
{
	CFrameWnd::OnMove(x, y);
}

LRESULT CMainFrame::OnUpdateColour(WPARAM wparam, LPARAM lparam)
{
    m_wndColour.Update();
    return 0;
}

LRESULT CMainFrame::OnUpdateCharSet(WPARAM wparam, LPARAM lparam)
{
    m_wndCharSet.Update();
    return 0;
}

LRESULT CMainFrame::OnAddMessage(WPARAM wparam, LPARAM lparam)
{
	CString* pstrMessage = (CString*)wparam;
	ASSERT(pstrMessage);
	if (!m_wndChat.IsVisible()) 
	{
		m_wndColour.SetChatFlag();
		m_wndColour.Update();
	}
    m_wndChat.AddMessage(*pstrMessage);
	delete pstrMessage;
    return 0;
}

LRESULT CMainFrame::OnUserJoined(WPARAM wparam, LPARAM lparam)
{
	CPabloDrawDoc* pDoc = (CPabloDrawDoc*)GetActiveDocument();
	CClientSocket* pSocket = pDoc->GetClientSocket();
	BOOL bAutosave = (LPARAM)lparam;

	if (bAutosave) pDoc->Autosave();
	// user joined, autosave if user wants to
	CString* pstrUser = (CString*)wparam;
	ASSERT(pstrUser);
    m_wndUserList.AddUser(*pstrUser);
	delete pstrUser;
    return 0;
}

LRESULT CMainFrame::OnUserParted(WPARAM wparam, LPARAM lparam)
{
	CString* pstrUser = (CString*)wparam;
	ASSERT(pstrUser);
	if (pstrUser)
	{
		m_wndUserList.RemoveUser(*pstrUser);
	}
	else
	{
		m_wndUserList.RemoveAllUsers();
		m_wndChat.AddMessage(_T("*** Disconnected"));
	}

    return 0;
}


void CMainFrame::OnSwitchChatEdit()
{
	if (GetFocus())
	{
		CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
		m_wndColour.SetChatFlag(FALSE);
		m_wndColour.Update();
		if (GetActiveView() && (GetActiveView()->IsChild(GetFocus()) || GetActiveView() == GetFocus()))
		{
			if (pApp->GetOptions()->GetStartInFullscreen() && (!m_wndChat.IsVisible() || !m_wndUserList.IsVisible()))
			{
				m_wndChat.ShowWindow(SW_SHOW);
				m_wndUserList.ShowWindow(SW_SHOW);
				DelayRecalcLayout();
			}
			if (m_wndChat.IsVisible() && m_wndChat.m_pChatView)
			{
				m_wndChat.m_pChatView->SetFocus();
			}
		}
		else
		{
			if (pApp->GetOptions()->GetStartInFullscreen() && (m_wndChat.IsVisible() || m_wndUserList.IsVisible()))
			{
				m_wndChat.ShowWindow(SW_HIDE);
				m_wndUserList.ShowWindow(SW_HIDE);
				DelayRecalcLayout();
			}
			GetActiveView()->SetFocus();
		}
	}
}

void CMainFrame::DockControlBarLeftOf(CControlBar* Bar, CControlBar* LeftOf)
{
	CRect rect;
	DWORD dw;
	UINT n;
	
	// get MFC to adjust the dimensions of all docked ToolBars
	// so that GetWindowRect will be accurate
	RecalcLayout(TRUE);
	
	LeftOf->GetWindowRect(&rect);
	rect.OffsetRect(1,0);
	dw=LeftOf->GetBarStyle();
	n = 0;
	n = (dw&CBRS_ALIGN_TOP) ? AFX_IDW_DOCKBAR_TOP : n;
	n = (dw&CBRS_ALIGN_BOTTOM && n==0) ? AFX_IDW_DOCKBAR_BOTTOM : n;
	n = (dw&CBRS_ALIGN_LEFT && n==0) ? AFX_IDW_DOCKBAR_LEFT : n;
	n = (dw&CBRS_ALIGN_RIGHT && n==0) ? AFX_IDW_DOCKBAR_RIGHT : n;
	
	// When we take the default parameters on rect, DockControlBar will dock
	// each Toolbar on a seperate line. By calculating a rectangle, we
	// are simulating a Toolbar being dragged to that location and docked.
	DockControlBar(Bar,n,&rect);
}


void CMainFrame::OnShowChatWindow()
{
	if (m_wndChat.IsVisible() || m_wndUserList.IsVisible())
	{
		m_wndChat.ShowWindow(SW_HIDE);
		m_wndUserList.ShowWindow(SW_HIDE);
	}
	else
	{
		m_wndColour.SetChatFlag(FALSE);
		m_wndColour.Update();

		m_wndChat.ShowWindow(SW_SHOW);
		m_wndUserList.ShowWindow(SW_SHOW);
	}
	DelayRecalcLayout();
}

void CMainFrame::OnUpdateShowChatWindow(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck((m_wndChat.IsVisible() || m_wndUserList.IsVisible()) ? TRUE : FALSE);
}

void CMainFrame::OnShowPreview()
{
	if (m_wndPreview.IsVisible())
	{
		m_wndPreview.ShowWindow((m_wndPreview.IsVisible()) ? SW_HIDE : SW_SHOW); 
	    m_pView->SetFocus();
	}
	else
	{
		m_wndPreview.ShowWindow((m_wndPreview.IsVisible()) ? SW_HIDE : SW_SHOW); 
		m_wndPreview.SetChildFocus();
	}
	DelayRecalcLayout();
}

void CMainFrame::OnUpdateShowPreview(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_wndPreview.IsVisible() ? TRUE : FALSE);
}
void CMainFrame::OnCanvasBreakconnection()
{
	GetDocument()->OnCanvasBreakconnection();
}
void CMainFrame::OnCanvasConnecttoserver()
{
	GetDocument()->OnCanvasConnecttoserver();
	if (GetDocument()->GetClientSocket())
	{
		m_wndChat.ShowWindow(SW_SHOW);
		m_wndUserList.ShowWindow(SW_SHOW);
		DelayRecalcLayout();
	}
}
void CMainFrame::OnCanvasStartserver()
{
	GetDocument()->OnCanvasStartserver();
	if (GetDocument()->GetClientSocket())
	{
		m_wndChat.ShowWindow(SW_SHOW);
		m_wndUserList.ShowWindow(SW_SHOW);
		DelayRecalcLayout();
	}
}
void CMainFrame::OnUpdateCanvasBreakconnection(CCmdUI* pCmdUI)
{
	GetDocument()->OnUpdateCanvasBreakconnection(pCmdUI);
}
void CMainFrame::OnUpdateCanvasConnecttoserver(CCmdUI* pCmdUI)
{
	GetDocument()->OnUpdateCanvasConnecttoserver(pCmdUI);
}
void CMainFrame::OnUpdateCanvasStartserver(CCmdUI* pCmdUI)
{
	GetDocument()->OnUpdateCanvasStartserver(pCmdUI);
}


void CMainFrame::OnViewCharacterSet()
{
	m_wndCharSet.ShowWindow((m_wndCharSet.IsVisible()) ? SW_HIDE : SW_SHOW); 
	DelayRecalcLayout();
}

void CMainFrame::OnUpdateViewCharacterSet(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck((m_wndCharSet.IsVisible()) ? TRUE : FALSE);
}

void CMainFrame::OnViewColourbar()
{
	m_wndColour.ShowWindow((m_wndColour.IsVisible()) ? SW_HIDE : SW_SHOW); 
	DelayRecalcLayout();
}

void CMainFrame::OnUpdateViewColourbar(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck((m_wndColour.IsVisible()) ? TRUE : FALSE);
}

void CMainFrame::OnSize(UINT nType, int cx, int cy)
{
	if (g_pDisplay == NULL && nType == SIZE_RESTORED) 
	{
		// remember the size if we're not in (or attempting) full-screen 
		GetWindowRect(g_rectWindowed);
	}
	CFrameWnd::OnSize(nType, cx, cy);
}


/////

void CMainFrame::OnCycleBackground8()
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pApp->GetOptions()->SetBackground8(!pApp->GetOptions()->GetBackground8());
	SendMessageToDescendants(WM_USER_UPDATE_CANVAS, 1);
	SendMessage(WM_USER_UPDATE_COLOUR);

}

void CMainFrame::OnUpdateCycleBackground8(CCmdUI *pCmdUI)
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pCmdUI->SetCheck(!pApp->GetOptions()->GetBackground8());
}

void CMainFrame::OnItpCompat()
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pApp->GetOptions()->SetITPArrows(!pApp->GetOptions()->GetITPArrows());
	SendMessageToDescendants(WM_USER_UPDATE_CANVAS, 2);
}

void CMainFrame::OnUpdateItpCompat(CCmdUI *pCmdUI)
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pCmdUI->SetCheck(pApp->GetOptions()->GetITPArrows());
}

void CMainFrame::OnBlinkingCursor()
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pApp->GetOptions()->SetBlinkingCursor(!pApp->GetOptions()->GetBlinkingCursor());
	SendMessageToDescendants(WM_USER_UPDATE_CANVAS, 3);
}

void CMainFrame::OnUpdateBlinkingCursor(CCmdUI *pCmdUI)
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pCmdUI->SetCheck(pApp->GetOptions()->GetBlinkingCursor());
}

void CMainFrame::OnUseShiftSelect()
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pApp->GetOptions()->SetShiftSelect(!pApp->GetOptions()->GetShiftSelect());
}

void CMainFrame::OnUpdateUseShiftSelect(CCmdUI *pCmdUI)
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pCmdUI->SetCheck(pApp->GetOptions()->GetShiftSelect());
}

void CMainFrame::OnNotepadMode()
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	CPabloDrawDoc* pDoc = (CPabloDrawDoc*)GetActiveDocument();
	CClientSocket* pSocket = pDoc->GetClientSocket();

	if (pSocket)
	{
		pSocket->SetNotepadMode(!pSocket->GetNotepadMode());
	}
	else
	{
		pApp->GetOptions()->SetNotepadMode(!pApp->GetOptions()->GetNotepadMode());
		SendMessageToDescendants(WM_USER_UPDATE_CANVAS, 4);
	}
}

void CMainFrame::OnUpdateNotepadMode(CCmdUI *pCmdUI)
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	CPabloDrawDoc* pDoc = (CPabloDrawDoc*)GetActiveDocument();
	CClientSocket* pSocket = pDoc->GetClientSocket();

	if (pSocket) pCmdUI->SetCheck(pSocket->GetNotepadMode());
	else pCmdUI->SetCheck(pApp->GetOptions()->GetNotepadMode());
}

void CMainFrame::OnEnableBackups()
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	CPabloDrawDoc* pDoc = (CPabloDrawDoc*)GetActiveDocument();

	pApp->GetOptions()->SetEnableBackups(!pApp->GetOptions()->GetEnableBackups());
}

void CMainFrame::OnUpdateEnableBackups(CCmdUI *pCmdUI)
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	CPabloDrawDoc* pDoc = (CPabloDrawDoc*)GetActiveDocument();

	pCmdUI->SetCheck(pApp->GetOptions()->GetEnableBackups());
}

void CMainFrame::OnMultipleBackups()
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	CPabloDrawDoc* pDoc = (CPabloDrawDoc*)GetActiveDocument();

	pApp->GetOptions()->SetMultipleBackups(!pApp->GetOptions()->GetMultipleBackups());
}

void CMainFrame::OnUpdateMultipleBackups(CCmdUI *pCmdUI)
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	CPabloDrawDoc* pDoc = (CPabloDrawDoc*)GetActiveDocument();

	pCmdUI->Enable(pApp->GetOptions()->GetEnableBackups());
	pCmdUI->SetCheck(pApp->GetOptions()->GetMultipleBackups());
}

void CMainFrame::OnSysCommand(UINT nID, LPARAM lParam)
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	switch (nID)
	{
		case SC_MOVE:
		case SC_SIZE:
		case SC_MAXIMIZE:
		case SC_MONITORPOWER:
			if( pApp->GetOptions()->GetStartInFullscreen() )
				return;
			break;
	}
	CFrameWnd::OnSysCommand(nID, lParam);
}

void CMainFrame::OnDestroy()
{
	CFrameWnd::OnDestroy();

	if (g_pDisplay) delete g_pDisplay;
}

void CMainFrame::OnUseWindowsKeysSwitch()
{
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pApp->GetOptions()->SetUseWindowsKeys(!pApp->GetOptions()->GetUseWindowsKeys());

	SetAccelerators(); // update main accelerators
	SendMessageToDescendants(WM_USER_UPDATE_CANVAS, 2); // update accelerators
	CreateMenu();
}

void CMainFrame::OnUpdateUseWindowsKeysSwitch(CCmdUI *pCmdUI)
{
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pCmdUI->SetCheck((pApp->GetOptions()->GetUseWindowsKeys()) ? 1 : 0);
}


void CMainFrame::OnUseTabKeySwitch()
{
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pApp->GetOptions()->SetUseTabKey(!pApp->GetOptions()->GetUseTabKey());

	SetAccelerators(); // update main accelerators
	SendMessageToDescendants(WM_USER_UPDATE_CANVAS, 2); // update accelerators
	CreateMenu();
}

void CMainFrame::OnUpdateUseTabKeySwitch(CCmdUI *pCmdUI)
{
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pCmdUI->SetCheck((pApp->GetOptions()->GetUseTabKey()) ? 1 : 0);
}

void CMainFrame::OnMiniSwitch()
{
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pApp->GetOptions()->SetStartInMini(!pApp->GetOptions()->GetStartInMini());

	if (pApp->GetOptions()->GetStartInFullscreen()) return; // don't do anything if we're in full-screen
	CString strOldSettings = (pApp->GetOptions()->GetStartInFullscreen()) ? FULLSCREEN_SETTINGS : NORMAL_SETTINGS;
	if (pApp->GetOptions()->GetStartInMini())
	{
		CSizingControlBar::GlobalSaveState(this, strOldSettings);
		SaveBarState(strOldSettings);

		m_wndToolBar.ShowWindow(SW_HIDE);
		m_wndPreview.ShowWindow(SW_HIDE);
		m_wndStatusBar.ShowWindow(SW_HIDE);
		LoadBarState(MINI_SETTINGS);
		CSizingControlBar::GlobalLoadState(this, MINI_SETTINGS);
	}
	else
	{
		SaveBarState(MINI_SETTINGS);
		CSizingControlBar::GlobalSaveState(this, MINI_SETTINGS);

		m_wndToolBar.ShowWindow(SW_SHOW);
		m_wndPreview.ShowWindow(SW_SHOW);
		m_wndStatusBar.ShowWindow(SW_SHOW);
		CSizingControlBar::GlobalLoadState(this, strOldSettings);
		LoadBarState(strOldSettings);
	}
	SendMessageToDescendants(WM_USER_MINI_SWITCH, (WPARAM)pApp->GetOptions()->GetStartInMini());
	DelayRecalcLayout();
}

void CMainFrame::OnUpdateMiniSwitch(CCmdUI *pCmdUI)
{
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pCmdUI->SetCheck((pApp->GetOptions()->GetStartInMini()) ? 1 : 0);
}

void CMainFrame::SwitchToFullScreen()
{
	HRESULT hr;
	HWND hwnd = AfxGetMainWnd()->GetSafeHwnd();
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	GetWindowRect(g_rectWindowed);


	if (g_pDisplay) delete g_pDisplay;
	g_pDisplay = new CDisplay();
	hr = g_pDisplay->CreateFullScreenDisplay( hwnd, 640, 400, 24 );
	if (!SUCCEEDED(hr)) hr = g_pDisplay->CreateFullScreenDisplay( hwnd, 640, 400, 16 );
	if (!SUCCEEDED(hr)) hr = g_pDisplay->CreateFullScreenDisplay( hwnd, 640, 480, 24 );
	if (!SUCCEEDED(hr)) hr = g_pDisplay->CreateFullScreenDisplay( hwnd, 640, 480, 16 );

	if( SUCCEEDED(hr) )
	{
		SetMenu(NULL);
		ModifyStyle(WS_CAPTION|WS_BORDER|WS_THICKFRAME|WS_SYSMENU, 0, SWP_FRAMECHANGED);
		
		MoveWindow(CRect(0,0,(int)g_pDisplay->GetWidth(), (int)g_pDisplay->GetHeight()));
		pApp->GetOptions()->SetStartInFullscreen(TRUE);

		m_wndToolBar.ShowWindow(SW_HIDE);
		m_wndPreview.ShowWindow(SW_HIDE);
		m_wndStatusBar.ShowWindow(SW_HIDE);
		LoadBarState(FULLSCREEN_SETTINGS);
		CSizingControlBar::GlobalLoadState(this, FULLSCREEN_SETTINGS);
		SendMessageToDescendants(WM_USER_FULLSCREEN_SWITCH, (WPARAM)pApp->GetOptions()->GetStartInFullscreen(), (LPARAM)1);
	}
	else
	{
		MoveWindow(g_rectWindowed);
		MessageBox(_T("Sorry, your video card does not support 640x400 or 640x480 in 16 or 24 bits"));
		delete g_pDisplay;
		g_pDisplay = NULL;
		pApp->GetOptions()->SetStartInFullscreen(FALSE);
	}
}
LRESULT CMainFrame::OnFullscreenSet(WPARAM wparam, LPARAM lparam)
{
	SwitchToFullScreen();
	return 0;
}

void CMainFrame::OnFullscreenSwitch()
{
	int iMenu = 0;
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();

	CString strOldSettings = (pApp->GetOptions()->GetStartInMini()) ? MINI_SETTINGS : NORMAL_SETTINGS;
	if (!pApp->GetOptions()->GetStartInFullscreen())
	{
		CSizingControlBar::GlobalSaveState(this, strOldSettings);
		SaveBarState(strOldSettings);
		SwitchToFullScreen();
	}
	else
	{
		SaveBarState(FULLSCREEN_SETTINGS);
		CSizingControlBar::GlobalSaveState(this, FULLSCREEN_SETTINGS);
		if (g_pDisplay) delete g_pDisplay;
		g_pDisplay = NULL;
		MoveWindow(g_rectWindowed);
		ModifyStyle(0, WS_CAPTION|WS_BORDER|WS_THICKFRAME|WS_SYSMENU, SWP_FRAMECHANGED);

		pApp->GetOptions()->SetStartInFullscreen(!pApp->GetOptions()->GetStartInFullscreen());
		if (GetMenu() == NULL)
		{
			SetMenu(&m_menu);
			iMenu = 2;
		}

		m_wndToolBar.ShowWindow(SW_SHOW);
		m_wndPreview.ShowWindow(SW_SHOW);
		m_wndStatusBar.ShowWindow(SW_SHOW);
		CSizingControlBar::GlobalLoadState(this, strOldSettings);
		LoadBarState(strOldSettings);
		SendMessageToDescendants(WM_USER_FULLSCREEN_SWITCH, (WPARAM)pApp->GetOptions()->GetStartInFullscreen(), (LPARAM)iMenu);
		if (pApp->GetOptions()->GetStartInMini()) SendMessageToDescendants(WM_USER_MINI_SWITCH, (WPARAM)pApp->GetOptions()->GetStartInMini(), (LPARAM)iMenu);
	}
	DelayRecalcLayout();
}

void CMainFrame::OnUpdateFullscreenSwitch(CCmdUI *pCmdUI)
{
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pCmdUI->SetCheck((pApp->GetOptions()->GetStartInFullscreen()) ? 1 : 0);
}

void CMainFrame::OnViewMenubar()
{
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	if (GetMenu())
	{
		SetMenu(NULL);
		SendMessageToDescendants(WM_USER_FULLSCREEN_SWITCH, (WPARAM)pApp->GetOptions()->GetStartInFullscreen(), 1);
	}
	else
	{
		SetMenu(&m_menu);
		SendMessageToDescendants(WM_USER_FULLSCREEN_SWITCH, (WPARAM)pApp->GetOptions()->GetStartInFullscreen(), 2);
	}
}

void CMainFrame::OnUpdateViewMenubar(CCmdUI *pCmdUI)
{
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pCmdUI->Enable(pApp->GetOptions()->GetStartInFullscreen());
}

void CMainFrame::OnUpdateInsert(CCmdUI *pCmdUI)
{
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pCmdUI->Enable(pApp->GetOptions()->GetInsertMode());
}

void CMainFrame::OnClose()
{
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	CString strState;
	CRect rectWindow;
	if (IsIconic() || IsZoomed()) rectWindow = g_rectWindowed;
	else GetWindowRect(rectWindow);
	if (pApp->GetOptions()->GetStartInFullscreen()) 
	{
		rectWindow = g_rectWindowed;
		strState = FULLSCREEN_SETTINGS;
	}
	else if (pApp->GetOptions()->GetStartInMini()) strState = MINI_SETTINGS;
	else strState = NORMAL_SETTINGS;
	CSizingControlBar::GlobalSaveState(this, strState);
	SaveBarState(strState);
	
	AfxGetApp()->WriteProfileInt(_T("defaults"), _T("main_zoomed"), (int)IsZoomed());
	AfxGetApp()->WriteProfileInt(_T("defaults"), _T("main_width"), (int)rectWindow.Width());
	AfxGetApp()->WriteProfileInt(_T("defaults"), _T("main_height"), (int)rectWindow.Height());
	
	CFrameWnd::OnClose();
}

void CMainFrame::OnViewToolbar()
{
	m_wndToolBar.ShowWindow((m_wndToolBar.IsVisible()) ? SW_HIDE : SW_SHOW);
	DelayRecalcLayout();
}

void CMainFrame::OnUpdateViewToolbar(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_wndToolBar.IsVisible() ? TRUE : FALSE);
}

BOOL CMainFrame::CreateMenu(void)
{
	m_cl.RemoveAll();
	m_cl.AddTail(cCommand(ID_FILE_NEW, 0, 0, 0, FALSE, _T("&New|New|Create a new file|Create a new file")));
	m_cl.AddTail(cCommand(ID_FILE_LOAD, 0, 0, 0, FALSE, _T("&Load...|Load|Load file|Load an existing file")));
	m_cl.AddTail(cCommand(ID_FILE_SAVE, 0, 0, 0, FALSE, _T("&Save")));
	m_cl.AddTail(cCommand(ID_FILE_SAVE_AS, 0, 0, 0, FALSE, _T("Save &As...")));
	m_cl.AddTail(cCommand(ID_FILE_PRINT, 0, 0, 0, FALSE, _T("&Print...")));
	m_cl.AddTail(cCommand(ID_FILE_PRINT_PREVIEW, 0, 0, 0, FALSE, _T("Print Pre&view")));
	m_cl.AddTail(cCommand(ID_FILE_PRINT_SETUP, 0, 0, 0, FALSE, _T("P&rint Setup...")));
	m_cl.AddTail(cCommand(ID_FILE_SEND_MAIL, 0, 0, 0, FALSE, _T("Sen&d...")));
	m_cl.AddTail(cCommand(ID_FILE_MRU_FILE1, 0, 0, 0, FALSE, _T("Recent File")));
	m_cl.AddTail(cCommand(ID_APP_EXIT, 0, 0, 0, FALSE, _T("E&xit|Exit|Exit PabloDraw|Exit PabloDraw")));

	m_cl.AddTail(cCommand(ID_VIEW_TOOLBAR, 0, 0, 0, FALSE, _T("&Toolbar")));
	m_cl.AddTail(cCommand(ID_VIEW_STATUS_BAR, 0, 0, 0, FALSE, _T("&Status Bar")));
	m_cl.AddTail(cCommand(ID_SHOW_CHAT_WINDOW, 0, 0, 0, FALSE, _T("&Chat Window")));
	m_cl.AddTail(cCommand(ID_VIEW_SHOW_PREVIEW, 0, 0, 0, FALSE, _T("&Preview Window")));
	m_cl.AddTail(cCommand(ID_VIEW_COLOURBAR, 0, 0, 0, FALSE, _T("C&olour Bar")));
	m_cl.AddTail(cCommand(ID_VIEW_CHARACTER_SET, 0, 0, 0, FALSE, _T("C&haracter Sets")));
	m_cl.AddTail(cCommand(ID_VIEW_80x50, 0, 0, 0, FALSE, _T("80x&50 Font")));
	m_cl.AddTail(cCommand(ID_VIEW_80x25, 0, 0, 0, FALSE, _T("80x&25 Font")));
	m_cl.AddTail(cCommand(ID_VIEW_AMIGA, 0, 0, 0, FALSE, _T("&Amiga Font")));
	m_cl.AddTail(cCommand(ID_FULLSCREEN_SWITCH, 0, 0, 0, FALSE, _T("&Full Screen")));
	m_cl.AddTail(cCommand(ID_MINI_SWITCH, 0, 0, 0, FALSE, _T("&Mini/Classic Mode")));

	m_cl.AddTail(cCommand(ID_APP_ABOUT, 0, 0, 0, FALSE, _T("&About")));

	m_cl.AddTail(cCommand(ID_CYCLE_BACKGROUND, 0, 0, 0, FALSE, _T("&Start Server...")));
	m_cl.AddTail(cCommand(ID_CANVAS_CONNECTTOSERVER, 0, 0, 0, FALSE, _T("&Connect to Server...")));
	m_cl.AddTail(cCommand(ID_CANVAS_BREAKCONNECTION, 0, 0, 0, FALSE, _T("&Break Connection")));
	m_cl.AddTail(cCommand(ID_CYCLE_BACKGROUND8, 0, 0, 0, FALSE, _T("iCE colours (no blinking)")));
	m_cl.AddTail(cCommand(ID_ITP_COMPAT, 0, 0, 0, FALSE, _T("ITP Compatibility (ctrl+arrows flipped)")));
	m_cl.AddTail(cCommand(ID_VIEW_BLINKINGCURSOR, 0, 0, 0, FALSE, _T("Blinking Cursor")));
	m_cl.AddTail(cCommand(ID_USE_SHIFTSELECT, 0, 0, 0, FALSE, _T("Use Shift+Arrows for selection")));
	m_cl.AddTail(cCommand(ID_VIEW_NOTEPADMODE, 0, 0, 0, FALSE, _T("&Notepad Mode (white background)")));
	m_cl.AddTail(cCommand(ID_ENABLEBACKUPS, 0, 0, 0, FALSE, _T("Enable &Backups")));
	m_cl.AddTail(cCommand(ID_MULTIPLEBACKUPS, 0, 0, 0, FALSE, _T("&Multiple Backups")));
	m_cl.AddTail(cCommand(ID_FILE_CANVAS_WIDTH, 0, 0, 0, FALSE, _T("Set Canvas &Width...")));
	m_cl.AddTail(cCommand(ID_USE_WINDOWSKEYS, 0, 0, 0, FALSE, _T("Use &Windows Keys (cut/paste, etc)")));
	m_cl.AddTail(cCommand(ID_USE_TABKEY, 0, 0, 0, FALSE, _T("Use &Tab key to insert tabs")));

/*
	m_cl.AddTail(cCommand(ID_, 0, 0, 0, FALSE, _T("")));
	m_cl.AddTail(cCommand(ID_, 0, 0, 0, FALSE, _T("")));
	m_cl.AddTail(cCommand(ID_, 0, 0, 0, FALSE, _T("")));
*/
	if (m_menu.m_hMenu != NULL) m_menu.DestroyMenu();
	m_cl.SetAccelerators(m_hAccelTable, TRUE, TRUE);
	m_menu.CreateMenu();

	cMenuItemList main(&m_cl);
	cMenuItemList sub(&m_cl);
	cMenuItemList subsub(&m_cl);
	cMenuItemList subsubsub(&m_cl);
	
	sub.RemoveAll();
	sub.AddTail(cMenuItem(ID_FILE_NEW));
	sub.AddTail(cMenuItem(ID_FILE_LOAD));
	sub.AddTail(cMenuItem(ID_FILE_SAVE));
	sub.AddTail(cMenuItem(ID_FILE_SAVE_AS));
	sub.AddTail(cMenuItem(ID_FILE_CANVAS_WIDTH));
	/*sub.AddTail(cMenuItem(MENUID_SEPARATOR));
	sub.AddTail(cMenuItem(ID_FILE_PRINT));
	sub.AddTail(cMenuItem(ID_FILE_PRINT_PREVIEW));
	sub.AddTail(cMenuItem(ID_FILE_PRINT_SETUP));*/
	sub.AddTail(cMenuItem(MENUID_SEPARATOR));
	sub.AddTail(cMenuItem(ID_FILE_SEND_MAIL));
	sub.AddTail(cMenuItem(MENUID_SEPARATOR));
	sub.AddTail(cMenuItem(ID_FILE_MRU_FILE1));
	sub.AddTail(cMenuItem(MENUID_SEPARATOR));
	sub.AddTail(cMenuItem(ID_APP_EXIT));

	main.AddTail(cMenuItem(MENUID_SUBMENU, FALSE, _T("&File"), &sub));

	sub.RemoveAll();
	m_pView->GetEditMenu(m_cl, sub);
	main.AddTail(cMenuItem(MENUID_SUBMENU, FALSE, _T("&Edit"), &sub));

	sub.RemoveAll();
	sub.AddTail(cMenuItem(ID_VIEW_TOOLBAR));
	sub.AddTail(cMenuItem(ID_VIEW_STATUS_BAR));
	sub.AddTail(cMenuItem(ID_SHOW_CHAT_WINDOW));
	sub.AddTail(cMenuItem(ID_VIEW_SHOW_PREVIEW));
	sub.AddTail(cMenuItem(MENUID_SEPARATOR));
	sub.AddTail(cMenuItem(ID_VIEW_80x50));
	sub.AddTail(cMenuItem(ID_VIEW_80x25));
	sub.AddTail(cMenuItem(ID_VIEW_AMIGA));
	sub.AddTail(cMenuItem(MENUID_SEPARATOR));
	sub.AddTail(cMenuItem(ID_VIEW_COLOURBAR));
	sub.AddTail(cMenuItem(ID_VIEW_CHARACTER_SET));
	sub.AddTail(cMenuItem(MENUID_SEPARATOR));
	sub.AddTail(cMenuItem(ID_FULLSCREEN_SWITCH));
	sub.AddTail(cMenuItem(ID_MINI_SWITCH));
	main.AddTail(cMenuItem(MENUID_SUBMENU, FALSE, _T("Vie&w"), &sub));

	sub.RemoveAll();
	sub.AddTail(cMenuItem(ID_CYCLE_BACKGROUND));
	sub.AddTail(cMenuItem(ID_CANVAS_CONNECTTOSERVER));
	sub.AddTail(cMenuItem(ID_CANVAS_BREAKCONNECTION));

	subsub.RemoveAll();

	subsub.AddTail(cMenuItem(ID_CYCLE_BACKGROUND8));
	subsub.AddTail(cMenuItem(ID_VIEW_BLINKINGCURSOR));
	subsub.AddTail(cMenuItem(ID_VIEW_NOTEPADMODE));
	subsub.AddTail(cMenuItem(MENUID_SEPARATOR));
	subsub.AddTail(cMenuItem(ID_ENABLEBACKUPS));
	subsub.AddTail(cMenuItem(ID_MULTIPLEBACKUPS));
	subsub.AddTail(cMenuItem(MENUID_SEPARATOR));
	subsubsub.RemoveAll();
	subsubsub.AddTail(cMenuItem(ID_ITP_COMPAT));
	subsubsub.AddTail(cMenuItem(ID_USE_WINDOWSKEYS));
	subsubsub.AddTail(cMenuItem(ID_USE_TABKEY));
	subsubsub.AddTail(cMenuItem(ID_USE_SHIFTSELECT));
	subsub.AddTail(cMenuItem(MENUID_SUBMENU, FALSE, _T("&Keyboard"), &subsubsub));
	sub.AddTail(cMenuItem(MENUID_SUBMENU, FALSE, _T("&Options"), &subsub));

	main.AddTail(cMenuItem(MENUID_SUBMENU, FALSE, _T("&Tools"), &sub));

	sub.RemoveAll();
	sub.AddTail(cMenuItem(ID_APP_ABOUT));
	main.AddTail(cMenuItem(MENUID_SUBMENU, FALSE, _T("&Help"), &sub));

	m_menu.AddMenu(&main);

	SetMenu(&m_menu);
	return TRUE;
}

void CMainFrame::OnSetCanvasWidth()
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	CPabloDrawDoc* pDoc = (CPabloDrawDoc*)GetActiveDocument();
	CClientSocket* pSocket = pDoc->GetClientSocket();


	CCanvasWidthDialog dlg;
	cPage* pPage = pDoc->GetCurrentPage();
	cCanvas* pCanvas = pPage->GetCanvas();
	dlg.m_lWidth = pCanvas->GetSize().cx;
	if (dlg.DoModal() == IDOK)
	{
		if (pSocket)
		{
			pSocket->ResizeCanvas(CSize(dlg.m_lWidth, pCanvas->GetSize().cy));
		}
		else
		{
			pCanvas->Resize(CSize(dlg.m_lWidth, pCanvas->GetSize().cy));
			pDoc->SendMessage(WM_USER_UPDATE_CANVAS);
			pDoc->UpdateAllViews(NULL);
		}
	}
}

void CMainFrame::OnUpdateSetCanvasWidth(CCmdUI* pCmdUI)
{
    CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	CPabloDrawDoc* pDoc = (CPabloDrawDoc*)GetActiveDocument();

	//pCmdUI->Enable(pDoc->GetClientSocket() == NULL);
}
