// ServerOptionsDialog.cpp : implementation file
//

#include "stdafx.h"
#include "PabloDraw.h"
#include "cFileDialog.h"
#include ".\serveroptionsdialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CServerOptionsDialog dialog


CServerOptionsDialog::CServerOptionsDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CServerOptionsDialog::IDD, pParent)
{
	m_uiPort = 700;
	m_strAlias = _T("");
}


void CServerOptionsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SPIN_PORT, m_ctlSpin);
	DDX_Text(pDX, IDC_EDIT_PORT, m_uiPort);
	DDV_MinMaxUInt(pDX, m_uiPort, 0, 65535);
	DDX_Text(pDX, IDC_EDIT_ALIAS, m_strAlias);
	DDV_MaxChars(pDX, m_strAlias, 30);
	m_ctlSpin.SetRange32(0,65535);
	DDX_Control(pDX, IDC_CHECK1, m_autosave);
	DDX_Control(pDX, IDC_EDIT1, m_editAutosave);
	DDX_Control(pDX, IDC_SELECT_FILE, m_bSelect);
	if (pDX->m_bSaveAndValidate)
	{
		if (m_strAlias.IsEmpty())
		{
			MessageBox(_T("You must enter an Alias"));
			pDX->Fail();
		}
		CString str;
		m_editAutosave.GetWindowText(str);
		if (m_autosave.GetCheck() == 1 && str.IsEmpty())
		{
			MessageBox(_T("Please specify an autosave file"));
			pDX->Fail();
		}
	}
}


BEGIN_MESSAGE_MAP(CServerOptionsDialog, CDialog)
	ON_BN_CLICKED(IDC_SELECT_FILE, OnBnClickedSelectFile)
	ON_BN_CLICKED(IDC_CHECK1, OnBnClickedCheck1)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CServerOptionsDialog message handlers
void CServerOptionsDialog::PreInitDialog()
{
	UpdateData(FALSE);
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	m_uiPort = (UINT)pApp->GetOptions()->GetServerPort();
	m_strAlias = pApp->GetOptions()->GetDefaultAlias();
	m_autosave.SetCheck(pApp->GetOptions()->GetServerAutosaveMultiuserConnect() ? 1 : 0);
	m_editAutosave.SetWindowText(pApp->GetOptions()->GetServerAutosaveFile());
	OnBnClickedCheck1();
	CDialog::PreInitDialog();
}

void CServerOptionsDialog::OnBnClickedSelectFile()
{
	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
    CString strFormat = pApp->GetFormatString(FMT_SAVE);

	DWORD dwFlags = OFN_HIDEREADONLY | OFN_ENABLESIZING | OFN_OVERWRITEPROMPT;
	cFileDialog fd(FALSE, NULL, NULL, dwFlags, strFormat);
    if (fd.DoModal() == IDOK)
    {
		m_editAutosave.SetWindowText(fd.GetPathName());
	}
}

void CServerOptionsDialog::OnBnClickedCheck1()
{
	if (m_autosave.GetCheck() == 1)
	{
		m_editAutosave.EnableWindow(TRUE);
		m_bSelect.EnableWindow(TRUE);
	}
	else 
	{
		m_editAutosave.EnableWindow(FALSE);
		m_bSelect.EnableWindow(FALSE);
	}
}

void CServerOptionsDialog::OnClose()
{

	CDialog::OnClose();
}

void CServerOptionsDialog::OnDestroy()
{
	CDialog::OnDestroy();

	CPabloDrawApp* pApp = (CPabloDrawApp*)AfxGetApp();
	pApp->GetOptions()->SetServerPort(m_uiPort);
	pApp->GetOptions()->SetDefaultAlias(m_strAlias);
	pApp->GetOptions()->SetServerAutosaveMultiuserConnect(m_autosave.GetCheck() == 1 ? TRUE : FALSE);
	CString str;
	m_editAutosave.GetWindowText(str);
	pApp->GetOptions()->SetServerAutosaveFile(str);
}
